/**
 *
 * D.O. u}[J[(X68K)
 *  FM.ONS -> OPMRo[^[
 *
 */

#include <stdio.h>
#include <memory.h>

#define OUT_OPM
//#define OUT_BIN

int main () {
	FILE *rfp = NULL, *wfp = NULL;
	unsigned char fnum = 0;

	try {
		rfp = fopen("FM.ONS", "rb");
		if (!rfp) {
			printf("no file\n");
			throw 1;
		}

#if defined(OUT_OPM)
		wfp = fopen("FM.OPM", "wb");
		if (!wfp) {
			printf("fs error\n");
			throw 2;
		}
#endif
		if (fread(&fnum, 1, 1, rfp) != 1) {
			throw 1;
		}

#if defined(OUT_BIN)
		char name_buf[16];
#endif
		unsigned char tone[0x40] = {0};
		unsigned char opmt[0x36] = {0};
		for (int i=0; i <= fnum; i++) {
			if (fread(tone, 1, 0x40, rfp) != 0x40) {
				printf("read error!\n");
			}
			if (i == 0) {
				continue;
			}
			memset(opmt, 0, sizeof(opmt));

			opmt[0x00] = tone[0x00];

			opmt[0x12] = (tone[0x01] & 0x0f);
			opmt[0x13] = ((tone[0x01] >> 4)& 0x07);
			opmt[0x28] = (tone[0x02] & 0x0f);
			opmt[0x29] = ((tone[0x02] >> 4)& 0x07);
			opmt[0x1d] = (tone[0x03] & 0x0f);
			opmt[0x1e] = ((tone[0x03] >> 4)& 0x07);
			opmt[0x33] = (tone[0x04] & 0x0f);
			opmt[0x34] = ((tone[0x04] >> 4)& 0x07);

			opmt[0x0b] = (tone[0x09] & 0x1f);
			opmt[0x11] = ((tone[0x09] >> 5)& 0x07);
			opmt[0x21] = (tone[0x0a] & 0x1f);
			opmt[0x27] = ((tone[0x0a] >> 5)& 0x07);
			opmt[0x16] = (tone[0x0b] & 0x1f);
			opmt[0x1c] = ((tone[0x0b] >> 5)& 0x07);
			opmt[0x2c] = (tone[0x0c] & 0x1f);
			opmt[0x32] = ((tone[0x0c] >> 5)& 0x07);

			opmt[0x0c] = (tone[0x0d] & 0x1f);
			opmt[0x22] = (tone[0x0e] & 0x1f);
			opmt[0x17] = (tone[0x0f] & 0x1f);
			opmt[0x2d] = (tone[0x10] & 0x1f);
			opmt[0x0d] = (tone[0x11] & 0x1f);
			opmt[0x23] = (tone[0x12] & 0x1f);
			opmt[0x18] = (tone[0x13] & 0x1f);
			opmt[0x2e] = (tone[0x14] & 0x1f);

			opmt[0x0e] = (tone[0x15] & 0x0f);
			opmt[0x0f] = ((tone[0x15] >> 4)& 0x0f);
			opmt[0x24] = (tone[0x16] & 0x0f);
			opmt[0x25] = ((tone[0x16] >> 4)& 0x0f);
			opmt[0x19] = (tone[0x17] & 0x0f);
			opmt[0x1a] = ((tone[0x17] >> 4)& 0x0f);
			opmt[0x2f] = (tone[0x18] & 0x0f);
			opmt[0x30] = ((tone[0x18] >> 4)& 0x0f);

			opmt[0x02] = (tone[0x1d] & 0x1f);

			opmt[0x06] = 0;	// ????

			opmt[0x00] &= 0xfc;
			opmt[0x00] |= (tone[0x37] & 0x03);

			opmt[0x10] = tone[0x38];
			opmt[0x26] = tone[0x39];

			if (tone[0x3a] > 0x0a) {
				opmt[0x1b] = tone[0x3a] - 0x0a;
			} else {
				opmt[0x1b] = 0;
			}
			if (tone[0x3b] > 0x0a) {
				opmt[0x31] = tone[0x3b] - 0x0a;
			} else {
				opmt[0x31] = 0;
			}

			opmt[0x01] = tone[0x3c];
			opmt[0x03] = 0x00;
			opmt[0x04] = 0xc8;
			opmt[0x07] = 0x01;
			opmt[0x15] = 0x00;
			opmt[0x2b] = 0x00;
			opmt[0x20] = 0x00;
			opmt[0x36] = 0x00;
			opmt[0x05] = 0x23;
			opmt[0x09] = 0x03;
			opmt[0x08] = 0x03;
			opmt[0x14] = 0x00;
			opmt[0x2a] = 0x00;
			opmt[0x1f] = 0x00;
			opmt[0x35] = 0x00;

#if defined(OUT_OPM)
			fprintf(wfp, "(v%d,0,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,1)\n",
					i,
					opmt[0x00], opmt[0x01],opmt[0x02],opmt[0x03],opmt[0x04],opmt[0x05],opmt[0x06],opmt[0x07],
					opmt[0x08], opmt[0x09],opmt[0x0a],opmt[0x0b],opmt[0x0c],opmt[0x0d],opmt[0x0e],opmt[0x0f],
					opmt[0x10], opmt[0x11],opmt[0x12],opmt[0x13],opmt[0x14],opmt[0x15],opmt[0x16],opmt[0x17],
					opmt[0x18], opmt[0x19],opmt[0x1a],opmt[0x1b],opmt[0x1c],opmt[0x1d],opmt[0x1e],opmt[0x1f],
					opmt[0x20], opmt[0x21],opmt[0x22],opmt[0x23],opmt[0x24],opmt[0x25],opmt[0x26],opmt[0x27],
					opmt[0x28], opmt[0x29],opmt[0x2a],opmt[0x2b],opmt[0x2c],opmt[0x2d],opmt[0x2e],opmt[0x2f],
					opmt[0x30], opmt[0x31],opmt[0x32],opmt[0x33],opmt[0x34],opmt[0x35]
					);
#endif
#if defined(OUT_BIN)
			sprintf(name_buf, "FM.%03d", i);
			printf("%s : \n", name_buf);
			wfp = fopen(name_buf, "wb");
			if (!wfp) {
				throw 2;
			}
			fwrite(opmt, 1, sizeof(opmt), wfp);
			fclose(wfp);
			wfp = NULL;
#endif
		}

		throw 0;
	} catch (int num) {
		if (rfp) {
			fclose(rfp);
		}
		if (wfp) {
			fclose(wfp);
		}
		return num;
	}
	return 0;
}
